import { Observable } from 'rxjs';
import { AfterViewInit, ChangeDetectorRef, NgZone, OnDestroy } from '@angular/core';
import { FormGroupDirective, NgControl, NgForm, ValidationErrors } from '@angular/forms';
import { NtFormFieldControl } from './form-field-control';
import { NtFormLabelWidthDirective } from './form-label-width.directive';
import { NtFormOrientation, NtFormOrientationDirective } from './form-orientation.directive';
export declare class NtFormFieldComponent implements AfterViewInit, OnDestroy {
    private _ngZone;
    private _changeDetectorRef;
    private _formLabelWidth;
    private _formOrientation;
    private readonly _destroy;
    private _labelVisible;
    private _labelWidth;
    private _orientation;
    private _selfLabelWidth;
    private _selfOrientation;
    private _markVisible;
    private _ngForm;
    _labelStyles: any;
    _groupStyles: any;
    _invalid: boolean;
    label: string;
    set labelVisible(value: boolean);
    get labelVisible(): boolean;
    set labelWidth(value: number);
    get labelWidth(): number;
    messages: {
        [key: string]: string;
    };
    set orientation(value: NtFormOrientation);
    get orientation(): NtFormOrientation;
    get horizontal(): boolean;
    get markVisible(): boolean;
    set markVisible(value: boolean);
    get required(): boolean | null;
    get errors(): ValidationErrors | null;
    control: NtFormFieldControl<any>;
    get ngControl(): NgControl | null;
    readonly statusChanges: Observable<any>;
    constructor(_ngZone: NgZone, _changeDetectorRef: ChangeDetectorRef, parentForm: NgForm, parentFormGroup: FormGroupDirective, _formLabelWidth: NtFormLabelWidthDirective, _formOrientation: NtFormOrientationDirective);
    ngAfterViewInit(): void;
    ngOnDestroy(): void;
    private _validate;
    _clearValidateMessage(): void;
    private _setHorizontalStyles;
}
